import Promise from 'bluebird';
/**
 * Make any changes you need to make to the database here
 * and return promise
 * 'this' is the mongoose object
 */

function updateCollectionWithIsQstackField(collection) {
    return collection.updateMany({}, { $set: { isQstack: false } });
}

export function up() {
    const db = this.connection.db;
    const relationshipsDb = db.collection('relationships');
    const dataBrokersDb = db.collection('databrokers');
    const timelineDb = db.collection('timelines');

    return Promise.resolve()
        .then(() => updateCollectionWithIsQstackField(relationshipsDb)
            .then(() => updateCollectionWithIsQstackField(dataBrokersDb))
            .then(() => updateCollectionWithIsQstackField(timelineDb)));
}

/**
 * Make any changes that UNDO the up function side effects here (if possible)
 * and return promise
 * 'this' is the mongoose object
 */
export function down() {
    return this.model('User').countDocuments();
}
