
/**
 * Make any changes you need to make to the database here
 * and return promise
 * 'this' is the mongoose object
 */
export async function up() {
    const db = this.connection.db;
    const usersDb = db.collection('users');
    const indexes = await usersDb.stats();
    if (indexes.indexDetails.email_1) {
        const indexInfo = indexes.indexDetails.email_1.metadata.infoObj;
        if (JSON.parse(indexInfo).unique) {
            await usersDb.dropIndex({email: 1});
            await usersDb.createIndex({email: 1});
        }
    }
    if (indexes.indexDetails.verificationCode_1) {
        await usersDb.dropIndex({verificationCode: 1});
    }
    await usersDb.update({}, {$unset: {verificationCode: '', verifiedAt: ''}}, {multi:true});
    //fix previous bug
    const relationships = db.collection('relationships');
    await relationships.update({}, {$unset: {statusObj: ''}}, {multi: true});
}

/**
 * Make any changes that UNDO the up function side effects here (if possible)
 * and return promise
 * 'this' is the mongoose object
 */
export function down() {
    return this.model('User').countDocuments();
}
