import mongoose from 'mongoose';
/**
 * Make any changes you need to make to the database here
 * and return promise
 * 'this' is the mongoose object
 */
export async function up() {
    const db = this.connection.db;
    const timelineV2 = db.collection('timelinev2');
    const recordsToUpdate = await timelineV2.find({'relationship.group': {$exists: true}}).toArray();
    const promises = recordsToUpdate.map(timeLineRecord => {
        timeLineRecord.relationship.group = mongoose.Types.ObjectId(timeLineRecord.relationship.group);
        timelineV2.save(timeLineRecord);
    });
    await Promise.all(promises);
}


/**
 * Make any changes that UNDO the up function side effects here (if possible)
 * and return promise
 * 'this' is the mongoose object
 */
export async function down() {
    return this.model('User').countDocuments();
}
