
/**
 * Make any changes you need to make to the database here
 * and return promise
 * 'this' is the mongoose object
 */
export async function up() {
    const db = this.connection.db;
    const relationshipDb = db.collection('relationships');
    const usersDb = db.collection('users');

    const users = await relationshipDb.distinct('user',
        {$or:[{'source.nfs.nfsType': 'cvs'}, {'target.nfs.nfsType': 'cvs'}, {'source.nfs.nfsType': 'anf'}, {'target.nfs.nfsType': 'anf'}, {'relationship.isQstack': true}]});
    await usersDb.update({'_id': {$in : users}}, {$set : {isQstack: true}}, {multi: true});

    await relationshipDb.update({$or:[{'source.nfs.nfsType': 'cvs'}, {'target.nfs.nfsType': 'cvs'}, {'source.nfs.nfsType': 'anf'}, {'target.nfs.nfsType': 'anf'}]},
        {$set: {isQstack: true}}, {multi:true});
}

/**
 * Make any changes that UNDO the up function side effects here (if possible)
 * and return promise
 * 'this' is the mongoose object
 */
export async function down() {
    return this.model('User').countDocuments();
}
