import { API_ROOT, SWAGGER_UI } from '../utils/consts';

import {getLogger} from '../utils/logger';
const logger = getLogger();

export default function reactRouterFallback(staticAssetsMiddleware) {
    return function(req, res, next) {
        if (req.url.startsWith(API_ROOT) || req.url.startsWith(SWAGGER_UI)) {
            next();
        } else {
            logger.debug('Requested resource not found:', req.originalUrl, ' . Redirecting...');
            req.url = '/';
            staticAssetsMiddleware(req, res, next);
        }
    };
}