import mongoose from 'mongoose';

const groupsSchema = new mongoose.Schema({
    user:           { type: mongoose.Schema.Types.ObjectId, ref: 'User', required: true, index: true },
    name:           {type: String, required: true},
    dataBrokers:    [{type: mongoose.Schema.Types.ObjectId, ref: 'DataBroker'}]
}, {
    timestamps: true,
    toJSON: {
        transform: (doc, ret) => {
            delete ret.updatedAt;
            delete ret['__v'];
            delete ret.user;
            delete ret['_id'];
            ret.id = doc.id;
            return ret;
        }
    }
});


groupsSchema.index({ user: 1,  name: 1 }, { unique: true});

export default mongoose.model('Group', groupsSchema);

