import express from 'express';
import mongoose from 'mongoose';
import {API_PATH_HEALTH_CHECK} from '../utils/consts';

import {getLogger} from '../utils/logger';

const logger = getLogger();
const router = express.Router();

router.get(API_PATH_HEALTH_CHECK, async(req, res, next) => {
    try {
        await mongoose.connection.db.admin().ping();
        res.sendStatus(200);

    } catch (err) {
        logger.error('Health check failed', err);
        next(err);
    }
});

export default router;
