import express from 'express';
import { API_PATH_MESSAGES, UI_POLLING_TIMEOUT_MS } from '../utils/consts';
import {poll} from '../utils/messages-poller';

const router = express.Router();

router.get(API_PATH_MESSAGES, async(req, res, next) => {
    const {user : { id: userId}, query : { last} } = req;
    try {
        const messages = await poll(userId, last, UI_POLLING_TIMEOUT_MS);
        res.json(messages);
    } catch (err) {
        next(err);
    }
});


export default router;
