import express from 'express';
import querystring from 'querystring';
import {API_PATH_SAAS_REGISTRATION} from '../utils/consts';

import {getLogger} from '../utils/logger';
const router = express.Router();
const logger = getLogger();

router.post(API_PATH_SAAS_REGISTRATION, (req, res) => {
    const token = querystring.escape(req.body['x-amzn-marketplace-token']);
    if (token) {
        res.redirect(`/?rt=${token}`);
    } else {
        logger.warn(`Landed on ${API_PATH_SAAS_REGISTRATION} page without a token`);
        res.redirect('/');
    }
});

export default router;