import express from 'express';
import Timeline from '../models/timeline';
import TimelineV2 from '../models/timeline-v2';
import {API_PATH_TIMELINES_V2, API_PATH_TIMELINES} from '../utils/consts';

const router = express.Router();

router.get(API_PATH_TIMELINES, async(req, res, next) => {
    try {
        const {user} = req;
        const timeLines = await Timeline.find({user}).sort({createdAt: -1}).limit(200).exec();
        res.json(timeLines);
    } catch (e) {
        next(e);
    }
});

router.get(API_PATH_TIMELINES_V2, async(req, res, next) => {
    try {
        const {user} = req;
        const timeLinesV2 = await TimelineV2.find({user}).sort({createdAt: -1}).limit(200).exec();
        res.json(timeLinesV2);
    } catch (e) {
        next(e);
    }
});


export default router;
