import nock from 'nock';
import * as consts from '../utils/consts';

nock('http://169.254.169.254')
    .persist()
    .get('/')
    .reply(200)
    .get('/latest/meta-data')
    .reply(200)
    .get('/latest/meta-data/placement/availability-zone')
    .reply(200, `${consts.REGION}a`)
    .get('/latest/meta-data/instance-id')
    .reply(200, consts.INSTANCE_ID)
    .get('/latest/meta-data/mac')
    .reply(200, consts.MAC)
    .get(`/latest/meta-data/network/interfaces/macs/${consts.MAC}/subnet-id`)
    .reply(200, consts.SUBNET_ID)
    .get(`/latest/meta-data/network/interfaces/macs/${consts.MAC}/subnet-ipv4-cidr-block`)
    .reply(200, consts.SUBNET_CIDR_BLOCK)
    .get(`/latest/meta-data/network/interfaces/macs/${consts.MAC}/vpc-id`)
    .reply(200, consts.VPC_ID)
    .get(`/latest/meta-data/network/interfaces/macs/${consts.MAC}/vpc-ipv4-cidr-block`)
    .reply(200, consts.VPC_CIDR_BLOCK)
    .get(`/latest/meta-data/network/interfaces/macs/${consts.MAC}/local-ipv4s`)
    .reply(200, '10.60.3.81');