import config from 'config';
import moment from 'moment';
import { createNamespace } from 'continuation-local-storage';
import addClsSupportForBluebird from 'cls-bluebird';
import addClsSupportForMongoose from 'cls-mongoose';

export const MP_PRODUCT_CODE_METERING = 'eb85xigzhaaz2x4tho48267nf';
export const MP_PRODUCT_CODE_CONTRACT = '5km6p97xpwwhji1zrgsrreos8';
export const MP_SUBSCRIPTION_STATUS_SNS_TOPIC = `arn:aws:sns:us-east-1:287250355862:aws-mp-subscription-notification-${MP_PRODUCT_CODE_METERING}`;
export const SELLER_ACCESS_KEY = 'AKIAJOCIY5BJE2OIS34Q';
export const SELLER_SECRET_KEY = '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';

export const IPA_SERVER_ADDRESS = config.get('ipa.server-address');

export const INTERCOM_APP_ID = config.get('intercom.app-id');
export const INTERCOM_SECRET = config.get('intercom.secret');

export const HUBSPOT_API_KEY = config.get('hubspot.api-key');

export const UI_PATH = config.get('paths.ui');
export const SWAGGER_SPEC_PATH = config.get('paths.swagger-spec');
export const SWAGGER_UI = '/docs';
export const SWAGGER_UI_PATH = config.get('paths.swagger-ui');

export const NEW_DATA_BROKER_INSTALLER_AWS_PATH = config.get('paths.agent.newInstaller.aws');
export const NEW_DATA_BROKER_AWS_CFT = config.get('paths.agent.newCfn.aws');
export const NEW_DATA_BROKER_GCP_CFT = config.get('paths.agent.newCfn.gcp');
export const NEW_DATA_BROKER_AZURE_CFN_PATH = config.get('paths.agent.newCfn.azure');
export const ASTERIX_EXPIRY_DATE = config.get('asterix-expiry-date');


export const NEW_DATA_BROKER_POLICY_DOCUMENT = config.get('paths.new-document-policy');
export const FAKE_USERS_FILE = config.get('paths.fake-users');
export const COST_RECORDS_SIMULATOR_FILE = config.get('paths.cost-records');
export const LOG4JS_FILE = config.get('paths.log4js');
export const API_ROOT = '/api';
export const API_PATH_SAAS_REGISTRATION = '/SaaS';
export const API_PATH_CONFIG = '/config';
export const API_PATH_HEALTH_CHECK = '/health-check';
export const API_PATH_MESSAGES_PREFIX = '/messages';
export const API_PATH_USERS_PREFIX = '/users';
export const API_PATH_USERS_INFO = `${API_PATH_USERS_PREFIX}/info`;
export const API_PATH_MESSAGES = `${API_PATH_MESSAGES_PREFIX}/client`;
export const API_PATH_GROUPS = '/groups';
export const API_PATH_DATA_BROKERS = '/data-brokers';
export const API_PATH_TIMELINES = '/timelines';
export const API_PATH_TIMELINES_V2 = '/timelines-v2';
export const API_PATH_RELATIONSHIP = '/relationships';
export const API_PATH_RELATIONSHIP_V2 = '/relationships-v2';
export const SERVER_HOST = config.get('server.host');
export const SERVER_HTTP_PORT = config.get('server.http-port');
export const SERVER_MAX_SOCKETS_PER_ORIGIN = config.get('server.max-sockets-per-origin');

export function getEmptyRelationship() {
    return {dataBroker: {}};
}

export const DB_CONNECTION_STRING = config.get('db');

export const MONGO_DB_ERROR_DUPLICATE_KEY = 11000;

export const AGENDA_PROCESS_EVERY = '10 seconds';
export const AGENDA_COLLECTION_NAME = 'jobs';
export const AGENDA_TASK_NAME_BACKUP_DB = 'BACKUP_DB';
export const AGENDA_TASK_INTERVAL_BACKUP_DB = config.get('agenda.backup-db-interval');
export const AGENDA_TASK_NAME_SYNC_SCHEDULER = 'SYNC_SCHEDULER';
export const AGENDA_TASK_INTERVAL_SYNC_SCHEDULER = config.get('agenda.schedule-sync-interval');
export const AGENDA_TASK_NAME_SAAS_METERING = 'SAAS_METERING';
export const AGENDA_TASK_NAME_UPDATE_DATABROKER = 'UPDATE_DATA_BROKER';
export const AGENDA_TASK_INTERVAL_UPDATE_DATABROKER = config.get('agenda.update-data-broker-scheduler');
export const AGENDA_TASK_INTERVAL_SAAS_METERING = config.get('agenda.saas-metering-interval');

export const JWT_SECRET = 'E3%c_mA~8^779}u';

export const JWT_TOKEN_AUTH0_PAYLOAD_FIELD_USER_ID = 'sub';
export const JWT_TOKEN_API_AUTH0_AUDIENCE = 'https://api.cloud.netapp.com';
export const JWT_TOKEN_CLOUD_MANAGER_AUTH0_AUDIENCE = 'https://cloudmanager.cloud.netapp.com';
export const JWT_TOKEN_AUTH0_PRODUCTION_URL = 'https://netapp-cloud-account.auth0.com';
export const JWT_TOKEN_AUTH0_TESTING_URL = 'https://staging-netapp-cloud-account.auth0.com';
export const PORTAL_LAMBDA__ARN_PRODUCTION = 'arn:aws:lambda:us-east-1:055518636490:function:portal-backend-prod-cloudSyncPusher';
export const PORTAL_LAMBDA__ARN_TESTING = 'arn:aws:lambda:us-east-1:055518636490:function:portal-backend-staging-cloudSyncPusher';

export const PRODUCTION_QSTACK_CLIENT_IDS = ['h9WqlUdmJ0hyy2em37COpqOhxMKmYS2o', 'PwAyihHCbPLpM75A9sjE8V4NqCd0Qp84'];
export const STAGING_QSTACK_CLIENT_IDS = ['effht1evvYFrw2rx3GzGf4v7h2fhCBjm', 'TxmKmfm4B0GEoPewxqpeupbd31jGb29o', 'c4NPSJa0gyTz2nkeXsSdlde6nh4Ij6Pd'];

export const LIVENESS_GRACE_FACTOR = 1.1;
export const UI_POLLING_TIMEOUT_MS = moment.duration(config.get('queues.ui.polling-timeout-seconds'), 'seconds').as('milliseconds');
export const DATA_BROKER_WASABI_STATUS_INTERVAL_MS = moment.duration(config.get('queues.data-broker.wasabi-status-interval-seconds'), 'seconds').as('milliseconds');
export const DATA_BROKER_PHOENIX_STATUS_INTERVAL_MS = moment.duration(config.get('queues.data-broker.phoenix-status-interval-seconds'), 'seconds').as('milliseconds');
export const DATA_BROKER_WASABI_LIVENESS_TIMEOUT_MS = LIVENESS_GRACE_FACTOR * DATA_BROKER_WASABI_STATUS_INTERVAL_MS;
export const DATA_BROKER_PHOENIX_LIVENESS_TIMEOUT_MS = LIVENESS_GRACE_FACTOR * DATA_BROKER_PHOENIX_STATUS_INTERVAL_MS;

export const DFIO_METADATA_BUCKET_NAME = config.get('dfio-metatdata-bucket.name');
export const DFIO_METADATA_BUCKET_REGION = config.get('dfio-metatdata-bucket.region');

export const DFIO_METADATA_BUCKET_BACKUPS_FOLDER = config.get('dfio-metatdata-bucket.backups-folder');

export const DATA_BROKER_CF_FOLDER = config.get('dfio-metatdata-bucket.data-broker-cf-folder');
export const DATA_BROKER_REPO_FOLDER = config.get('dfio-metatdata-bucket.data-broker-repo-folder');
export const DATA_BROKER_BUNDLE_LABEL = config.get('dfio-metatdata-bucket.data-broker-bundle-label');

export const MESSAGE_DATA_BROKER_OFFLINE = 'Data Broker is offline';
export const STATUS_SUCCESS = 'success';
export const MESSAGE_STATUS_DONE = 'DONE';
export const MESSAGE_STATUS_FAILED = 'FAILED';
export const MESSAGE_STATUS_INTERRUPTED = 'INTERRUPTED';
export const MESSAGE_STATUS_ABORTED = 'ABORTED';
export const MESSAGE_STATUS_ABORTING = 'ABORTING';
export const INTERRUPTED_MESSAGE = 'Sync was interrupted. Please try again';
export const ABORTED_MESSAGE = 'Sync was aborted by the user';
export const FAILED_AFTER_STARTUP_MESSAGE = 'Relationship\'s initial copy was interrupted. You should delete the relationship and start over';
export const TIMELINE_DELETED_RELATIONSHIP_MESSAGE = 'Relationship was deleted during action';

export const RUNNING_STATUS = 'RUNNING';
export const SYNC_TYPE = 'Sync';
export const COPY_RELATIONSHIP_MESSAGE = 'create-relationship-v2';
export const SYNC_RELATIONSHIP_MESSAGE = 'sync-relationship';
export const ABORT_RELATIONSHIP = 'abort-relationship';
export const STARTUP_RELATIONSHIP = 'startup';

export const TRIAL_EXPIRATION_MS = moment.duration(config.get('trial-period-days'), 'days').as('milliseconds');

export const CLOUD_FORMATION_ALL_REGIONS_LINK = 'https://console.aws.amazon.com/cloudformation/home';

export const SAAS_REGISTRATION_STATUS_UNSUBSCRIBED_INIT = 'unsubscribed-init';
export const SAAS_REGISTRATION_STATUS_RESOLVE_FAILED = 'resolve-failed';
export const SAAS_REGISTRATION_STATUS_SUBSCRIBE_SUCCESS = 'subscribe-success';

export const PAYGO_SUBSCRIPTION = 'PAYGO';
export const CONTRACT_SUBSCRIPTION = 'CONTRACT';

export const TIER_1_BILLING_PER_HOUR = 0.150;
export const TIER_2_BILLING_PER_HOUR = 0.100;
export const TIER_3_BILLING_PER_HOUR = 0.085;

export const SERVICE_REGION = 'us-east-1';

export const AWS_REGIONS = {
    'us-east-1': 'US East (N. Virginia)',
    'us-east-2': 'US East (Ohio)',
    'us-west-1': 'US West (N. California)',
    'us-west-2': 'US West (Oregon)',
    'eu-west-1': 'EU (Ireland)',
    'eu-west-2': 'EU (London)',
    'eu-central-1': 'EU (Frankfurt)',
    'ap-south-1': 'Asia Pacific (Mumbai)',
    'ap-northeast-1': 'Asia Pacific (Tokyo)',
    'ap-northeast-2': 'Asia Pacific (Seoul)',
    'ap-southeast-1': 'Asia Pacific (Singapore)',
    'ap-southeast-2': 'Asia Pacific (Sydney)',
    'sa-east-1': 'South America (S\u00E3o Paulo)',
    'ca-central-1': 'Canada (Central)',
    'us-gov-west-1': 'GovCloud (US)'
};

export const GCP_REGIONS = {
    'northamerica-northeast1': 'Canada (Montr\u00E9al)',
    'us-central1': 'US Central (Iowa)',
    'us-east1': 'US East (South Carolina)',
    'us-east4': 'US East (Northern Virginia)',
    'us-west1': 'US West (Oregon)',
    'us-west2': 'US West (Los Angeles)',
    'southamerica-east-1': 'South America (S\u00E3o Paulo)',
    'europe-north1': 'EU West (Finland)',
    'europe-west1': 'EU West (Belgium)',
    'europe-west2': 'EU West (London)',
    'europe-west3': 'EU West (Frankfurt)',
    'europe-west4': 'EU West (Netherlands)',
    'asia-east1': 'Asia East (Taiwan)',
    'asia-northeast1': 'Asia North-East (Tokyo)',
    'asia-south1': 'Asia South (Mumbai)',
    'asia-southeast1': 'Asia South-East (Singapore)',
    'australia-southeast1': 'Australia (Sydney)',
    'asia': 'Asia',
    'eu': 'EU',
    'us': 'US'
};

export const LOCAL_STORAGE_REQUEST_ID_KEY = 'requestId';
export const LOCAL_STORAGE_REQUEST_KEY = 'request';
export const LOCAL_STORAGE_RESPONSE_KEY = 'response';
export const LOCAL_STORAGE_ACTION_KEY = 'action';
export const LOCAL_STORAGE_NAMESPACE = createNamespace('io.datafabric');

export const S3_TAG_KEY_REGEXP = /^(?!aws:)([\d\s\w+-=._:/]{1,128}$)/;
export const S3_TAG_VALUE_REGEXP = /^(?!aws:)([\d\s\w+-=._:/]{1,256}$)/;

export const ALLOWED_SOURCE_AND_TARGET = {
    cifs: ['s3', 'sgws', 'cifs', 'nfs'],
    nfs: ['s3', 'sgws', 'cifs', 'nfs'],
    s3: ['cifs', 'nfs']
};

export const ALLOWED_NEW_DATABROKER_SOURCE_AND_TARGET = {
    nfs: ['s3', 'nfs', 'local', 'azure', 'cifs', 'sgws', 'gcp'],
    cifs: ['s3', 'nfs', 'local', 'azure', 'cifs', 'sgws', 'gcp'],
    s3: ['nfs', 'local', 'cifs', 's3', 'sgws'],
    sgws: ['nfs', 'local', 'cifs', 's3', 'sgws'],
    local: ['s3', 'nfs', 'local', 'azure', 'cifs', 'sgws', 'gcp'],
    azure: ['local', 'nfs', 'cifs', 'azure'],
    gcp: ['nfs', 'cifs', 'local']
};

export const SCAN_MODE_SOURCE_AND_TARGET = 'SCAN_MODE_SOURCE_AND_TARGET';


addClsSupportForBluebird(LOCAL_STORAGE_NAMESPACE);
addClsSupportForMongoose(LOCAL_STORAGE_NAMESPACE);
