import Promise from 'bluebird';
import moment from 'moment';
import _ from 'lodash';
import uuid from 'uuid';

export function requestId() {
    return uuid.v4();
}

export function isEmptyString(str) {
    return _.isEmpty(_.trim(str));
}

export function dateDiffMs(from, to) {
    return moment(to).diff(moment(from), 'milliseconds');
}

export function timeout(ms) {
    return new Promise(resolve => setTimeout(resolve, ms));
}

export const defaultTransform = f => (doc, ret, options) => {
    if (ret.createdAt) {
        ret.createdAt = ret.createdAt.getTime();
    }
    delete ret.updatedAt;
    delete ret['__v'];
    delete ret.user;
    delete ret['_id'];
    if (ret.id) {
        ret.id = doc.id;
    }
    return f(doc, ret, options);
};

export function removeFirstSlash(path) {
    return (path) ? (path.startsWith('/') ? path.substr(1) : path) : '';
}
