import chai from 'chai';
import chaiAsPromised from 'chai-as-promised';
import chaiDateTime from 'chai-datetime';
import chaiShallowDeepEqual from 'chai-shallow-deep-equal';
import mongoose from 'mongoose';
import Promise from 'bluebird';
import { DB_CONNECTION_STRING } from '../src/utils/consts';

mongoose.Promise = Promise; // use bluebird with mongoose
// prepare chai
chai.config.includeStack = false;
chai.config.showDiff = true;
chai.config.truncateThreshold = 0;
chai.use(chaiShallowDeepEqual);
chai.use(chaiAsPromised);
chai.use(chaiDateTime);
export const { expect, assert } = chai;
export const should = chai.should();

before(done => {
    mongoose.connect(DB_CONNECTION_STRING, err => {
        done(err);
    });
});

after(() => {
    mongoose.connection.close();
});
