import { should } from '../globals';
import Message from '../../src/models/message';

describe.skip('Message Model', () => {
    const queue = 'queue';
    const payload = { some: 'thing' };

    describe('CRUD', () => {
        it('create', () => Message.create({ queue, payload })
            .then(message => {
                should.exist(message);
                message.queue.should.equal(queue);
                message.payload.should.deep.equal(payload);
                should.exist(message.createdAt);
                should.exist(message.updatedAt);
            }));

        it('get', () => Message.create({ queue, payload })
            .then(message => Message.findOne({ _id: message.id }))
            .then(message => {
                should.exist(message);
                message.queue.should.equal(queue);
                message.payload.should.deep.equal(payload);
                should.exist(message.createdAt);
                should.exist(message.updatedAt);
            }));

        it('update', () => {
            const updatedQueue = 'updatedQueue';
            return Message.create({ queue, payload })
                .then(message => {
                    message.queue = updatedQueue;
                    return message.save();
                })
                .then(message => Message.findOne({ _id: message.id }))
                .then(message => {
                    should.exist(message);
                    message.queue.should.equal(updatedQueue);
                    message.payload.should.deep.equal(payload);
                    should.exist(message.createdAt);
                    should.exist(message.updatedAt);
                });
        });

        it('delete', () => Message.create({ queue, payload })
            .then(message => Message.deleteOne({ _id: message.id }))
            .then(message => Message.findOne({ _id: message.id }))
            .should.eventually.not.exist);
    });
});

